## freefem++ 4.14+dfsg

=== 3rdparty/ff-petsc/Makefile ===
# ======================================================================
# Laboratoire Jacques-Louis Lions
# Université Pierre et Marie Curie-Paris6, UMR 7598, Paris, F-75005 France
# http://www.ljll.math.upmc.fr/lehyaric
# ======================================================================
# This file is part of Freefem++
#
# Freefem++ is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Freefem++ is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Freefem++; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
# ======================================================================
# headeralh default=0 freefem make multipleauthors start=19/03/10 upmc

include Makefile.inc

PYTHON ?=

DIR_INSTALL_REAL:=$(FF_prefix_petsc)/r
DIR_INSTALL_COMPLEX:=$(FF_prefix_petsc)/c
VERSION=$(shell grep "'petsc-" ../getall | perl -pe '($$_)=/([0-9]+([.][0-9]+)+)/')
PACKAGE=../pkg/petsc-$(VERSION).tar.gz
SRCDIR=petsc-$(VERSION)
PETSC_DIR:=$(shell pwd)/$(SRCDIR)

W_SUDO:=$(SHELL mkdir -p "$(DESTDIR)$(FF_prefix_petsc)" && test -w "$(DESTDIR)$(FF_prefix_petsc) || echo sudo)
ifeq ($(COMPILE_OPENBLAS),openblas)
PETSC_OPENBLAS := --download-f2cblaslapack
PETSC_OPENBLAS_C := --with-blaslapack-dir=$(DIR_INSTALL_REAL)
else
PETSC_OPENBLAS = --with-blaslapack-include='$(shell echo $(BLASINC) | sed "s/-I//g")' \
		--with-blaslapack-lib='$(BLAS_LAPACK_LIBS)'
PETSC_OPENBLAS_C = $(PETSC_OPENBLAS)
endif
PETSC_DOWNLOAD_C := --with-metis-dir=$(DIR_INSTALL_REAL) \
		--with-ptscotch-dir=$(DIR_INSTALL_REAL) \
		--with-superlu-dir=$(DIR_INSTALL_REAL) \
		--with-suitesparse-dir=$(DIR_INSTALL_REAL) \
		--with-parmetis-dir=$(DIR_INSTALL_REAL) \
		--with-tetgen-dir=$(DIR_INSTALL_REAL)
PETSC_DOWNLOAD := --download-metis --download-ptscotch \
		--download-hypre --download-parmetis \
		--download-superlu --download-suitesparse --download-tetgen
ifneq ($(TOOL_DYLIB_mmg),)
PETSC_DOWNLOAD += --download-mmg
PETSC_DOWNLOAD_C += --with-mmg-dir=$(DIR_INSTALL_REAL)
ifneq ($(TOOL_DYLIB_parmmg),)
PETSC_DOWNLOAD += --download-parmmg
PETSC_DOWNLOAD_C += --with-parmmg-dir=$(DIR_INSTALL_REAL)
endif
endif
ifeq ($(FFCMAKE),no)
PETSC_DOWNLOAD := $(PETSC_DOWNLOAD) --download-cmake
endif
PETSC_DOWNLOAD_C := $(PETSC_DOWNLOAD_C) --download-htool --download-htool-commit=946875d79d0036afb4dc2c0c13c165a607d830df
ifeq ($(FF_generic_petsc), yes)
FLAGS_MTUNE := -mtune=generic
else
FLAGS_MTUNE := -mtune=native
endif
unexport MAKEFLAGS
COMMON_FLAGS := --with-debugging=0 COPTFLAGS='-O3 $(FLAGS_MTUNE)' CXXOPTFLAGS='-O3 $(FLAGS_MTUNE)' FOPTFLAGS='-O3 $(FLAGS_MTUNE)' --with-ssl=0 --with-x=0 --with-fortran-bindings=0 --with-cudac=0 --with-tau-perfstubs=0 \
		--download-slepc --download-hpddm

ifneq ($(wildcard ~/.petsc_pkg),)
COMMON_FLAGS += --with-packages-download-dir=~/.petsc_pkg
endif

ifeq ($(FC),)
COMMON_FLAGS += --with-fc=0
PETSC_DOWNLOAD += --download-superlu_dist
PETSC_DOWNLOAD_C += --with-superlu_dist-dir=$(DIR_INSTALL_REAL)
endif

ifeq ($(MPICC)$(MPICXX),)
ifeq ($(WIN32DLLTARGET),)
PETSC_DOWNLOAD += --with-cc='$(CC)' --with-cxx='$(CXX)' --download-mpich
PETSC_DOWNLOAD_C += --with-mpi-dir=$(DIR_INSTALL_REAL)
ifneq ($(FC),)
PETSC_DOWNLOAD += --with-fc='$(FC)'
endif
endif
else
COMMON_FLAGS += --with-cc='$(MPICC)' --with-cxx='$(MPICXX)'
ifneq ($(MPIFC),)
COMMON_FLAGS += --with-fc='$(MPIFC)'
endif
endif

ifeq ($(WIN32DLLTARGET),)
ifneq ($(FC),)
ifneq ($(wildcard ~/.petsc_pkg),)
PETSC_DOWNLOAD += --download-slepc-configure-arguments="--download-arpack --with-packages-download-dir=~/.petsc_pkg"
else
PETSC_DOWNLOAD += --download-slepc-configure-arguments="--download-arpack"
endif
endif
endif

ifneq ($(FC),)
ifneq ($(TOOL_DYLIB_scalapack)$(TOOL_DYLIB_mumps),)
PETSC_DOWNLOAD += --download-scalapack --download-mumps
PETSC_DOWNLOAD_C += --with-scalapack-dir=$(DIR_INSTALL_REAL) --with-mumps-dir=$(DIR_INSTALL_REAL)
else
PETSC_DOWNLOAD += --download-superlu_dist
PETSC_DOWNLOAD_C += --with-superlu_dist-dir=$(DIR_INSTALL_REAL)
endif
endif

ifneq ($(WIN32DLLTARGET),)
COMMON_FLAGS += --with-shared-libraries=0 \
	CXXFLAGS='-fno-stack-protector -Wno-stringop-overflow' \
	CFLAGS='-fno-stack-protector -Wno-stringop-overflow' \
	FFLAGS='$(FCFLAGS)' \
	--with-mpiexec='/C/Program\ Files/Microsoft\ MPI/Bin/mpiexec'
ifneq ($(FC),)
ifneq ($(wildcard ~/.petsc_pkg),)
PETSC_DOWNLOAD += '--download-slepc-configure-arguments=--with-packages-build-dir=$(PETSC_DIR)/fr/externalpackages --download-arpack --with-packages-download-dir=~/.petsc_pkg'
else
PETSC_DOWNLOAD += '--download-slepc-configure-arguments=--with-packages-build-dir=$(PETSC_DIR)/fr/externalpackages --download-arpack'
endif
endif
endif

FLAGS_CONF_PETSC_REAL = $(COMMON_FLAGS) --with-scalar-type=real $(PETSC_OPENBLAS) $(PETSC_DOWNLOAD)
FLAGS_CONF_PETSC_COMPLEX = $(COMMON_FLAGS) --with-scalar-type=complex $(PETSC_OPENBLAS_C) $(PETSC_DOWNLOAD_C)

all-local:
	@echo make ..
	@echo " # To build petsc and slepc do $ make petsc-slepc"
	@echo " # warning you have no write acces in $(DESTDIR)$(FF_prefix_petsc)"
	@echo " # need sudo if '$(W_SUDO)' == 'sudo' .."
	@echo " # run under root "
	@echo " # or create / add access to $(DESTDIR)$(FF_prefix_petsc) "
	@echo " # do for examples:"
	@echo " # PETSC_DOWNLOAD = $(PETSC_DOWNLOAD)"
	@echo "	sudo mkdir $(DESTDIR)$(FF_prefix_petsc)"
	@echo "	sudo chown -R $(LOGNAME) $(DESTDIR)$(FF_prefix_petsc)"
	@echo "	make petsc-slepc "

MPI_DIR:=$(shell dirname "$(MPI_INC_DIR)")
W_MPICC:=$(strip $(shell which mpicc))
SUDO_WITH_ENV=$(if $(SUDO), $(SUDO) -E)
ifeq ($(LAPACKLIBS), $(BLASLIBS))
  BLAS_LAPACK_LIBS=$(LAPACKLIBS)
else
  BLAS_LAPACK_LIBS=$(LAPACKLIBS) $(BLASLIBS)
endif

petsc-slepc: Makefile.inc dir-install WHERE-all
recompile: recompile-real recompile-complex
recompile-real:
	-rm */tag-make-real
	-rm */tag-install-real
	make WHERE
recompile-complex:
	-rm */tag-make-complex
	-rm */tag-install-complex
	@if [ -n "$(MPI_INCLUDE)" ]; then $(MAKE) -f Makefile.complex WHERE-complex ;\
	else echo " -- No PETSc, no MPI"; fi

dir-install: Makefile.inc
	-$(SUDO) mkdir -p $(DESTDIR)$(DIR_INSTALL_REAL)
	-$(SUDO) chown ${USER} $(DESTDIR)$(DIR_INSTALL_REAL)
	-$(SUDO) mkdir -p $(DESTDIR)$(DIR_INSTALL_COMPLEX)
	-$(SUDO) chown ${USER} $(DESTDIR)$(DIR_INSTALL_COMPLEX)
	@if test -w 	"$(DESTDIR)$(DIR_INSTALL_REAL)" -a -w 	"$(DESTDIR)$(DIR_INSTALL_COMPLEX)" ; then echo "no need of sudo"; echo > do-sudo; \
	else \
	 echo no write access in $(DESTDIR)$(DIR_INSTALL_REAL) and $(DESTDIR)$(DIR_INSTALL_COMPLEX); \
	 echo " do: make petsc-slepc SUDO=sudo "; \
	 echo " or add write access to 2 directory "; \
	 echo sudo >do-sudo; \
	fi
	test -e "$(DESTDIR)$(DIR_INSTALL_REAL)" -a -e "$(DESTDIR)$(DIR_INSTALL_COMPLEX)"
PETSc-real:
	@if [ -n "$(MPI_INCLUDE)" ]; then $(MAKE) WHERE ;\
	else echo " -- No PETSc, no MPI"; fi

PETSc-complex:
	@if [ -n "$(MPI_INCLUDE)" ]; then $(MAKE) -f Makefile.complex WHERE-complex ;\
	else echo " -- No PETSc, no MPI, no PETSc real"; fi

WHERE:../lib/WHERE.PETSc ../lib/WHERE.SLEPc

../lib/WHERE.PETSc:$(SRCDIR)/tag-install-real
	-mkdir ../lib
	echo 'petsc LD -Wl,-rpath,"$(DIR_INSTALL_REAL)/lib" -L"$(DIR_INSTALL_REAL)/lib" -lpetsc' > $@
	echo 'petsc INCLUDE -I"$(DIR_INSTALL_REAL)/include"' >> $@

$(SRCDIR)/tag-make-real:$(SRCDIR)/tag-conf-real
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fr all
	touch $@


$(SRCDIR)/tag-install-real :$(SRCDIR)/tag-make-real
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fr install-lib
	cd $(SRCDIR) && export HWLOC_HIDE_ERRORS=2 && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fr check
	test -e $(DIR_INSTALL_REAL)/include/petsc.h
	test -e $(DIR_INSTALL_REAL)/lib/petsc/conf/petscvariables
	touch $@

Makefile.inc:../../config.status Makefile Makefile-PETSc.inc
	../../config.status --file="Makefile.inc:Makefile-PETSc.inc"

$(SRCDIR)/tag-conf-real:$(SRCDIR)/tag-tar
	cd $(SRCDIR) && $(PYTHON) ./configure --prefix=$(DIR_INSTALL_REAL) \
		$(FLAGS_CONF_PETSC_REAL) PETSC_ARCH=fr
	test -f $(SRCDIR)/fr/lib/petsc/conf/petscvariables
	mkdir -p $(SRCDIR)/fc/externalpackages || true
	cp -r $(SRCDIR)/fr/externalpackages/git.slepc $(SRCDIR)/fr/externalpackages/git.hpddm $(SRCDIR)/fc/externalpackages || true
	touch $@
Make-petsc-download.mk:$(SRCDIR)/tag-install-real
	test -e $(DIR_INSTALL_REAL)/lib/petsc/conf/petscvariables
	egrep 'PETSC_LIB_BASIC|SCALAPACK_|METIS_|MUMPS_|HPDDM_|HTOOL_|TETGEN_|SUPERLU_|MMG_|PTSCOTCH_|SUITESPARSE_' $(DIR_INSTALL_REAL)/lib/petsc/conf/petscvariables | sed 's/-I/ /g'|sort >$@
ifdef 	COMPLEX_CASE
#  version COMPLEX.....
$(SRCDIR)/tag-conf-complex:$(SRCDIR)/tag-tar Make-petsc-download.mk
	cd $(SRCDIR) && $(PYTHON) ./configure --prefix=$(DIR_INSTALL_COMPLEX) \
		$(FLAGS_CONF_PETSC_COMPLEX) PETSC_ARCH=fc
	test -f $(SRCDIR)/fc/lib/petsc/conf/petscvariables
	touch $@

$(SRCDIR)/tag-make-complex:$(SRCDIR)/tag-conf-complex Make-petsc-download.mk
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fc all
	touch $@

$(SRCDIR)/tag-install-complex :$(SRCDIR)/tag-make-complex
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fc install-lib
	test -e $(DIR_INSTALL_COMPLEX)/include/petsc.h
	touch $@
WHERE-complex:../lib/WHERE.PETSc-complex ../lib/WHERE.SLEPc-complex

../lib/WHERE.PETSc-complex:$(SRCDIR)/tag-install-complex
	test -e $(DIR_INSTALL_COMPLEX)/include/petsc.h
	-mkdir ../lib
	echo 'petsccomplex LD -Wl,-rpath,"$(DIR_INSTALL_COMPLEX)/lib" -L"$(DIR_INSTALL_COMPLEX)/lib" -lpetsc' > $@
	echo 'petsccomplex INCLUDE -I"$(DIR_INSTALL_COMPLEX)/include"' >> $@
	echo done $@
../lib/WHERE.SLEPc-complex:
	test -e $(DIR_INSTALL_COMPLEX)/include/slepc.h
	-mkdir ../lib
	echo 'slepccomplex LD -Wl,-rpath,"$(DIR_INSTALL_COMPLEX)/lib" -L"$(DIR_INSTALL_COMPLEX)/lib" -lslepc' > $@
	echo 'slepccomplex INCLUDE -I"$(DIR_INSTALL_COMPLEX)/include"' >> $@
	echo done $@

WHERE-all:Makefile WHERE WHERE-complex
	echo >$@
	test -z '$(SCALAPACK_LIB)' || echo scalapack LD $(SCALAPACK_LIB) >>$@
	test -z '$(SCALAPACK_INCLUDE)' || echo scalapack INCLUDE -I$(SCALAPACK_INCLUDE) >>$@
	test -z '$(METIS_LIB)' || echo metis LD $(METIS_LIB) >>$@
	test -z '$(METIS_INCLUDE)' || echo metis INCLUDE -I$(METIS_INCLUDE) >>$@
	test -z '$(MUMPS_LIB)' || echo mumps LD $(MUMPS_LIB) >>$@
	test -z '$(MUMPS_INCLUDE)' || echo mumps INCLUDE -I$(MUMPS_INCLUDE) >>$@
	test -z '$(SUPERLU_LIB)' || echo superlu LD $(SUPERLU_LIB) >>$@
	test -z '$(SUPERLU_INCLUDE)' || echo superlu INCLUDE -I$(SUPERLU_INCLUDE) >>$@
	test -z '$(MMG_LIB)' || echo mmg LD $(MMG_LIB) >>$@
	test -z '$(MMG_INCLUDE)' || echo mmg INCLUDE -I$(MMG_INCLUDE) >>$@
	test -z '$(PARMMG_LIB)' || echo parmmg LD $(PARMMG_LIB) >>$@
	test -z '$(PARMMG_INCLUDE)' || echo parmmg INCLUDE -I$(PARMMG_INCLUDE) >>$@
	test -z '$(PTSCOTCH_LIB)' || echo ptscotch LD $(PTSCOTCH_LIB) >>$@
	test -z '$(PTSCOTCH_INCLUDE)' || echo ptscotch INCLUDE -I$(PTSCOTCH_INCLUDE) >>$@
	test -z '$(TETGEN_LIB)' || echo tetgen LD $(TETGEN_LIB) >>$@
	test -z '$(TETGEN_INCLUDE)' || echo tetgen INCLUDE -I$(TETGEN_INCLUDE) >>$@
	test -z '$(PARMETIS_LIB)' || echo parmetis LD $(PARMETIS_LIB) >>$@
	test -z '$(PARMETIS_INCLUDE)' || echo parmetis INCLUDE -I$(PARMETIS_INCLUDE) >>$@
	test -z '$(HPDDM_LIB)' || echo hpddm LD $(HPDDM_LIB) >>$@
	test -z '$(HPDDM_INCLUDE)' || echo hpddm INCLUDE -I$(HPDDM_INCLUDE) >>$@
	test -z '$(HTOOL_LIB)' || echo htool LD $(HTOOL_LIB) >>$@
	test -z '$(HTOOL_INCLUDE)' || echo htool INCLUDE -I$(HTOOL_INCLUDE) >>$@
	echo 'petsc LD -Wl,-rpath,"$(DIR_INSTALL_REAL)/lib" -L"$(DIR_INSTALL_REAL)/lib" -lpetsc' >>$@
	echo 'petsc INCLUDE -I"$(DIR_INSTALL_REAL)/include"' >>$@

=== examples/tutorial/CMakeLists.txt ===
FILE(GLOB EDP_FILES *.edp)


# Tests which are known to fail are removed from test list
LIST(REMOVE_ITEM EDP_FILES ${CMAKE_CURRENT_SOURCE_DIR}/exception.edp
                           ${CMAKE_CURRENT_SOURCE_DIR}/Laplace-RHS-Dirac.edp
                           ${CMAKE_CURRENT_SOURCE_DIR}/regtests.edp)



IF(NOT FREEFEM_MEDIT_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/tutorial/Newton.edp)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/tutorial/medit.edp)
ENDIF(NOT FREEFEM_MEDIT_INSTALLED)

IF(NOT FREEFEM_MSH3_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/tutorial/sphere.edp)
ENDIF(NOT FREEFEM_MSH3_INSTALLED)

FOREACH(EDP_FILE ${EDP_FILES})
  GET_FILENAME_COMPONENT(FILENAME ${EDP_FILE} NAME_WE)
  ADD_TEST(NAME ${FILENAME} COMMAND ${CMAKE_BINARY_DIR}/src/FreeFem++ ${EDP_FILE}
                            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/examples/tutorial)
ENDFOREACH(EDP_FILE)

=== cmake/modules/scotch/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

PROJECT(scotch C)

FILE(GLOB CFILES ${CMAKE_SOURCE_DIR}/src/libscotch/*.c)
LIST(REMOVE_ITEM CFILES ${CMAKE_SOURCE_DIR}/src/libscotch/bgraph_bipart_df_loop.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/bdgraph.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/bdgraph_bipart_bd.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/bdgraph_bipart_df.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/bdgraph_bipart_df_loop.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/bdgraph_bipart_ex.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/bdgraph_bipart_ml.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/bdgraph_bipart_sq.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/bdgraph_bipart_st.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/bdgraph_bipart_zr.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/bdgraph_check.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/bdgraph_gather_all.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/bdgraph_store.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/comm.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/common_sort.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_allreduce.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_band.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_band_grow.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_build.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_build_grid3d.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_build_hcub.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_check.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_coarsen.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_fold.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_fold_comm.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_fold_dup.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_gather.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_gather_all.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_ghst.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_halo.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_halo_fill.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_io_load.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_io_save.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_induce.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_match.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_match_check.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_match_scan.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_match_sync_coll.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_match_sync_ptop.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_redist.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_scatter.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dgraph_view.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dmapping.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dmapping_io.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dorder.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dorder_gather.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dorder_io.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dorder_io_block.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dorder_io_tree.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dorder_perm.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/dorder_tree_dist.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/graph_coarsen.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/graph_coarsen_edge.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/graph_match_scan.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/hdgraph.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/hdgraph_check.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/hdgraph_fold.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/hdgraph_gather.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/hdgraph_order_io.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/hdgraph_order_nd.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/hdgraph_order_si.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/hdgraph_order_sq.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/hdgraph_order_st.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/hdgraph_induce.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/hgraph_induce.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/hgraph_induce_edge.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/kgraph_map_df_loop.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/kdgraph.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/kdgraph_gather.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/kdgraph_map_rb.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/kdgraph_map_rb_map.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/kdgraph_map_rb_part.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/kdgraph_map_st.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_band.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_band_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_band_grow.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_build.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_build_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_build_grid3d.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_build_grid3d_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_check.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_check_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_coarsen.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_coarsen_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_gather.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_gather_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_grow.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_halo.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_halo_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_induce.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_induce_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_io_load.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_io_load_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_io_save.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_io_save_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_io_stat_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_io_map_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_map.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_map_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_map_view.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_map_view_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_stat_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_order.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_order_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_order_gather.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_order_gather_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_order_io.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_order_io_block.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_order_io_block_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_order_io_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_order_perm.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_order_perm_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_order_tree_dist.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_order_tree_dist_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_redist.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_redist_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_scatter.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_scatter_f.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dgraph_stat.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dmapping.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_dorder.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/library_error.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/vdgraph.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/vdgraph_check.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/vdgraph_gather_all.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/vdgraph_separate_bd.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/vdgraph_separate_df.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/vdgraph_separate_ml.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/vdgraph_separate_sq.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/vdgraph_separate_st.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/vdgraph_separate_zr.c
                        ${CMAKE_SOURCE_DIR}/src/libscotch/vdgraph_store.c)

ADD_LIBRARY(scotch ${CFILES})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src/libscotch)

ADD_LIBRARY(scotcherr ${CMAKE_SOURCE_DIR}/src/libscotch/library_error.c)

=== debian/changelog ===
freefem++ (4.14+dfsg-1build5) plucky; urgency=medium

  * No-change rebuild against libhdf5-310

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 27 Jan 2025 17:59:59 +0000

freefem++ (4.14+dfsg-1build4) plucky; urgency=medium

  * No-change rebuild for openmpi

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 06 Dec 2024 10:38:37 +0000

freefem++ (4.14+dfsg-1build3) plucky; urgency=medium

  * No-change rebuild for libsuperlu7

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 26 Nov 2024 09:48:18 +0000

freefem++ (4.14+dfsg-1build2) oracular; urgency=medium

  * No-change rebuild against mpi-defaults 1.17

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 30 Aug 2024 18:58:44 +0000

freefem++ (4.14+dfsg-1build1) oracular; urgency=medium

  * Rebuild against new libgsl28.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 30 Jul 2024 08:37:32 +0200

freefem++ (4.14+dfsg-1) unstable; urgency=medium

  * New upstream version.

 -- Francois Mazen <mzf@debian.org>  Sat, 13 Apr 2024 17:40:52 +0200

=== debian/control ===
Source: freefem++
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>,
           Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>,
           Francois Mazen <mzf@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libsuperlu-dev,
               gawk,
               gfortran,
               rdfind,
               symlinks,
               libhdf5-dev,
               flex,
               bison,
               libxt-dev,
               libxext-dev,
               libxxf86vm-dev,
               libxpm-dev,
               libmumps-scotch-dev,
               libmumps-ptscotch-dev,
               libfltk1.3-dev,
               freeglut3-dev,
               ghostscript,
               imagemagick,
               texlive,
               texlive-extra-utils,
               texlive-latex-extra,
               texlive-font-utils,
               libfftw3-dev,
               libgsl-dev,
               libhypre-dev,
               libarpack2-dev,
               libsuitesparse-dev,
               libmumps-dev,
               libscalapack-mpi-dev,
               libscotch-dev,
               libptscotch-dev,
               libmetis-dev,
               libmumps-seq-dev,
               libnlopt-dev,
               coinor-libipopt-dev,
               libgmm++-dev,
               libtet1.5-dev,
               libpetsc-real-dev,
               libpetsc-complex-dev,
               unzip,
               autoconf-archive
# libmmg3dlib4.0-4.0-dev, freeyams, mshmet, mshint,
# libparms2-dev, libitsol-dev,
# libhips-dev, libpastix-dev,
# libsuperlu-dist-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/freefempp
Vcs-Git: https://salsa.debian.org/science-team/freefempp.git
Homepage: http://www.freefem.org/ff++/
Rules-Requires-Root: no

Package: freefem++
Architecture: any
Section: math
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Provides the binaries of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the executables of FreeFem++.

Package: libfreefem++
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Provides the shared libraries of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the shared libraries of FreeFem++.

Package: libfreefem++-dev
Architecture: any
Section: libdevel
Depends: libfreefem++,
         ${shlibs:Depends},
         ${misc:Depends}
Description: Provides the development files of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the development files of FreeFem++.

Package: freefem++-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Provides the documentation of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the documentation files of FreeFem++.
